﻿String.prototype.trim = function(){
	newString = this;
	
	while(newString.charAt(0) == ' '){
		newString = newString.substring(1);
	}
	
	while(newString.charAt(newString.length-1) == ' '){
		newString = newString.substring(0, newString.length - 1);
	}
	
	return newString;
};

String.prototype.capitalize = function(){
	var name = this;
	
	const insertCapitalAfter = function(word, character){
		word = word.split(character);
		
		for(var i = 0; i < word.length; i++){
			word[i] = word[i].charAt(0).toUpperCase() + word[i].substring(1);
		}
		
		word = word.join(character);
		
		return word;
	};
	
	name = name.toLowerCase();
	name = insertCapitalAfter(name, " ");
	name = insertCapitalAfter(name, "-");
	
	return name;
};
	
String.prototype.isIP = function(){
	return /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/.exec(this) == this;
};

const countryLookup = new function(){
	var lookupDatabaseString = '';
	var lookupDatabase = new Array(5);
	var temp = new Array();
	var databaseParsedUntil = 0;
	var databaseReadyLoading = false;
	
	var _locale;
	
	var multipart = '';
	
	var prefs;
	
	const loadLookupDatabase = function(){
		var req = new XMLHttpRequest();
		req.open('GET', 'chrome://countrylookup/content/ip-to-country.csv', true);
		
		req.onreadystatechange = function(aEvt){
			if(req.readyState == 4){
				lookupDatabaseString = req.responseText;
				parseLookupDatabaseString();
				countryLookup.parseLookupDatabase();
			}
		};
		
		req.send(null);
	};
	
	const constructLookupDatabase = function(){
		for(var i = 0; i <= 4; i++){
			lookupDatabase[i] = new Array(10);
			for(var j = 0; j <= 10; j++){
				lookupDatabase[i][j] = new Array(10);
				for(var k = 0; k <= 10; k++){
					lookupDatabase[i][j][k] = new Array(10);
				}
			}
		}
	};
	
	const parseLookupDatabaseString = function(){
		temp = lookupDatabaseString.split('\r\n');
	};
	
	this.parseLookupDatabase = function(){
		/** LookupDatabase format: ******************************
		 *                                                      *
		 *       [0]\            0 -   999 999 999              *
		 *           \[0][0]\          0 -  99 999 999          *
		 *                   \[0][0][0]          0 -  9 999 999 *
		 *                    [0][0][1] 10 000 000 - 19 999 999 *
		 *                    [0][0][2] 20 000 000 - 29 999 999 *
		 *                    [0][0][3] 30 000 000 - 39 999 999 *
		 *            [0][1] 100 000 000 - 199 999 999          *
		 *            [0][2] 200 000 000 - 299 999 999          *
		 *            [0][3] 300 000 000 - 399 999 999          *
		 *       [1] 1 000 000 000 - 1 999 999 999              *
		 *       [2] 2 000 000 000 - 2 999 999 999              *
		 *       [3] 3 000 000 000 - 3 999 999 999              *
		 *       [4] 4 000 000 000 - 4 294 967 295              *
		 *                                                      *
		 ********************************************************/
			
		// E.g., 3 212 000 000 - 6 132 000 000 has to go in categories:
		// [3][2][1] to [6][1][3]
		//
		// [ 3 ][ 2 ][1-9] C
		// [ 3 ][3-9][ * ] B
		// [4-5][ * ][ * ] A
		// [ 6 ][0-0][ * ] B
		// [ 6 ][ 1 ][0-3] C
		//
		// [      scat1      ][      scat2      ][scat3-  9  ] Cs
		// [      scat1      ][scat2+1 -    9   ][     *     ] Bs
		// [scat1+1 - ecat1-1][        *        ][     *     ] A
		// [      ecat1      ][    0   - ecat1-1][     *     ] Be
		// [      ecat1      ][      ecat1      ][  0  -ecat3] Ce
		
		while(databaseParsedUntil < temp.length){
			thisArray = temp[databaseParsedUntil].substring(1, temp[databaseParsedUntil].length-1).split('","');
			
			var scat1 = thisArray[0];
			var ecat1 = thisArray[1];
			
			var scat2 = scat1 % 1000000000;
			var ecat2 = ecat1 % 1000000000;
			
			scat1 = (scat1 - scat2) / 1000000000;
			ecat1 = (ecat1 - ecat2) / 1000000000;
			
			var scat3 = scat2 % 100000000;
			var ecat3 = ecat2 % 100000000;
			
			scat2 = (scat2 - scat3) / 100000000;
			ecat2 = (ecat2 - ecat3) / 100000000;
			
			var scat4 = scat3 % 10000000;
			var ecat4 = ecat3 % 10000000;
			
			scat3 = (scat3 - scat4) / 10000000;
			ecat3 = (ecat3 - ecat4) / 10000000;
			
			// A
			for(var j = scat1+1; j <= ecat1-1; j++){
				for(k in lookupDatabase[j]){
					for(l in lookupDatabase[j][k]){
						lookupDatabase[j][k][l][lookupDatabase[j][k][l].length] = thisArray;
					}
				}
			}
			
			// Bs
			if(scat1 == ecat1){
				end = ecat2-1;
			} else {
				end = 9;
			}
			for(var j = scat2+1; j <= end; j++){
				for(k in lookupDatabase[scat1][j]){
					lookupDatabase[scat1][j][k][lookupDatabase[scat1][j][k].length] = thisArray;
				}
			}
			
			// Be
			if(scat1 == ecat1){
				// We already did it above
			} else {
				for(var j = 0; j <= ecat2-1; j++){
					for(k in lookupDatabase[ecat1][j]){
						lookupDatabase[ecat1][j][k][lookupDatabase[ecat1][j][k].length] = thisArray;
					}
				}
			}
			
			// Cs
			if(scat1 == ecat1 && scat2 == ecat2){
				end = ecat3;
			} else {
				end = 9;
			}
			for(var j = scat3; j <= end; j++){
				lookupDatabase[scat1][scat2][j][lookupDatabase[scat1][scat2][j].length] = thisArray;
			}
			
			// Ce
			if(scat1 == ecat1 && scat2 == ecat2){
				// We already did it above
			} else {
				for(var j = 0; j <= ecat3; j++){
					lookupDatabase[ecat1][ecat2][j][lookupDatabase[ecat1][ecat2][j].length] = thisArray;
				}
			}
			
			databaseParsedUntil++;
			
			if(databaseParsedUntil % 50 == 0){
				// Take a break
				setTimeout("countryLookup.parseLookupDatabase();", 0);
				break;
			}
		}
		
		if(databaseParsedUntil == temp.length){
			temp = null;
			lookupDatabaseString = null;
			databaseParsedUntil = null;
			databaseReadyLoading = true;
		}
	};
	
	const inet_aton = function(address){
		address = address.split(".");
		
		number = address[0]*256*256*256 + address[1]*256*256 + address[2]*256 + Number(address[3]);
		
		return number;
	};
	
	const lookupIP = function(address){
		address = inet_aton(address);
		
		countryCode = "UN";
		countryName = _locale.getString("Unknown");
		
		var cat1 = address;
		
		var cat2 = cat1 % 1000000000;		
		cat1 = (cat1 - cat2) / 1000000000;
		
		var cat3 = cat2 % 100000000;		
		cat2 = (cat2 - cat3) / 100000000;
		
		var cat4 = cat3 % 10000000;		
		cat3 = (cat3 - cat4) / 10000000;
		
		for(var i in lookupDatabase[cat1][cat2][cat3]){
			if(lookupDatabase[cat1][cat2][cat3][i][0] <= address && address <= lookupDatabase[cat1][cat2][cat3][i][1]){
				countryCode = lookupDatabase[cat1][cat2][cat3][i][2];
				countryName = lookupDatabase[cat1][cat2][cat3][i][4];
			}
		}
		
		return new function(){
			this.code = countryCode;
			this.name = countryName;
		};
	};
	
	const isPrivate = function(address){
		// Is the supplied IP address part of a private network or loopback?
		// http://www.iana.org/faqs/abuse-faq.htm#SpecialUseAddresses
		var number = inet_aton(address);
		
		if(
		// Private use
		   (167772160 <= number && number <= 184549375)
		|| (2886729728 <= number && number <= 2887778303)
		|| (3232235520 <= number && number <= 3232301055)
		// Loopback
		|| (2130706432 <= number && number <= 2147483647)
		// I don't think the following ones are possible, but anyway
		// Autoconfiguration
		|| (2851995648 <= number && number <= 2852061183)
		// Multicast
		|| (3758096384 <= number && number <= 4026531839)
		){
			return true;
		} else {
			return false;
		}
	};
	
	const queryCity = function(address, country){
		var req = new XMLHttpRequest();
		
		req.open('GET', 'http://api.hostip.info/rough.php?position=true&ip=' + address, true);
		
		req.onreadystatechange = function(aEvt){
			if(req.readyState == 4){
				try{
					if(req.status && req.status == 200){
						response = req.responseText.split("\n");
						
						var newCountry = new Object();
						
						for(i in response){
							if(response[i].indexOf("Country: ") == 0){
								newCountry.name = response[i].substring(9).capitalize();
							} else if(response[i].indexOf("Country Code: ") == 0){
								newCountry.code = response[i].substring(14).toLowerCase();
							} else if(response[i].indexOf("City: ") == 0){
								newCountry.city = response[i].substring(6);
							} else if(response[i].indexOf("Latitude: ") == 0){
								newCountry.latitude = response[i].substring(10);
							} else if(response[i].indexOf("Longitude: ") == 0){
								newCountry.longitude = response[i].substring(11);
							}
						}
						
						if(country.code == "un" || country.code == newCountry.code){
							country.name = newCountry.name;
							country.code = newCountry.code;
							country.city = newCountry.city;
							country.latitude = newCountry.latitude;
							country.longitude = newCountry.longitude;
						}
					}
				} catch (e){}
				
				switch(country.city){
					case "(Unknown city)":
					case "(Unknown City?)":
						delete(country.city);
				}
				
				countryLookup.mapOpener.updateCountry(country);
				document.getElementById("countryLookupIcon").width  = "48px";
				document.getElementById("countryLookupIcon").height = "48px";
				document.getElementById("countryLookupIcon").src    = "chrome://countrylookup/content/flags/" + country.code + ".png";
				document.getElementById("countryLookupIcon").setAttribute("tooltiptext", (country.city?country.city:_locale.getString("UnknownCity")) + ', ' + country.name);
			}
		};
		
		req.send(null);
	};
	
	const dispRoute = function(){
		var originIP = null;
		
		var receivedHeaders = new Array();
		var IPArray = new Array();
		
		var xOriginatingIP = null;
		
		var foundMultipart = false;
		
		// This fixes a bug related to multipart messages
		// I think this is a bug in EnigMail, but whatever, the fix is easy
		// START FIX
		for(i in currentHeaderData){
			if (
				 currentHeaderData[i].headerName.toLowerCase() == "content-type"
			&& currentHeaderData[i].headerValue.indexOf('multipart') == 0
			) {
				foundMultipart = true;
				if(multipart == currentHeaderData[i].headerValue){
					return;
				} else {
					multipart = currentHeaderData[i].headerValue;
				}
			}
		}
		
		if(!foundMultipart){
			multipart = '';
		}
		// END FIX
		
		// Get all Received headers
		for(i in currentHeaderData){
			if (currentHeaderData[i].headerName.toLowerCase() == "received") {
				receivedHeaders[receivedHeaders.length] = currentHeaderData[i].headerValue;
			}
		}
		receivedHeaders.reverse();
		
		for(var i = receivedHeaders.length-1; i>=0; i--){
			var currentIPs = receivedHeaders[i].match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/g);
			if(currentIPs != null){
				IPArray = IPArray.concat(currentIPs);
			}
		}
		
		// Look for X-Originating-IP header
		for(i in currentHeaderData){
      if (currentHeaderData[i].headerName.toLowerCase() == "x-originating-ip") {
				xOriginatingIP = currentHeaderData[i].headerValue;
				if(xOriginatingIP.charAt(0) == "["){
					xOriginatingIP = xOriginatingIP.substring(1, xOriginatingIP.length-1)
				}
			}
		}
		
		// If X-Originating-IP isn't set, why bother?
		// If X-Originating-IP is also in the Received headers,
		// the Received headers know better.
		// If X-Originating-IP is private, ignore.
		// Else, it almost certainly is from Hotmail or another web
		// based e-mail service imitating them. In this case
		// X-Originating-IP is the best guess.
		if(xOriginatingIP != null && IPArray.indexOf(xOriginatingIP) == -1 && !isPrivate(xOriginatingIP)){
			originIP = xOriginatingIP;
		} else {
			for(var i in IPArray){
				// Private network IPs are of no use to us!
				if(!isPrivate(IPArray[i])){
					originIP = IPArray[i];
					break;
				}
			}
		}
		
		if(originIP == null){
			// Maybe it's an NNTP message
			for (var i in currentHeaderData) {
				if (currentHeaderData[i].headerName.toLowerCase() == "nntp-posting-host") {
					originIP = currentHeaderData[i].headerValue;
				}
			}
		}
    
    if(originIP == null || !prefs.getBoolPref('load-local-database')){
			var country = new function(){
				this.code = "UN";
				this.name = _locale.getString("Unknown");
			};
    } else {
			var country = lookupIP(originIP);
    }
        
    country.code = country.code.toLowerCase();
    country.name = country.name.capitalize();
		country.IP = originIP;
        
    if(country.code == "un" && originIP != null){
			countryLookup.mapOpener.updateCountry(country);
			document.getElementById("countryLookupIcon").width  = "20px";
			document.getElementById("countryLookupIcon").height = "20px";
			document.getElementById("countryLookupIcon").src    = "chrome://messenger/skin/icons/throbber.gif";
			document.getElementById("countryLookupIcon").setAttribute("tooltiptext", _locale.getString("Loading"));
    } else {
			countryLookup.mapOpener.updateCountry(country);
			document.getElementById("countryLookupIcon").width  = "48px";
			document.getElementById("countryLookupIcon").height = "48px";
			document.getElementById("countryLookupIcon").src    = "chrome://countrylookup/content/flags/" + country.code + ".png";
			document.getElementById("countryLookupIcon").setAttribute("tooltiptext", _locale.getString("NoCityYet") + ", " + country.name);
    }
		
		queryCity(originIP, country);
	};
	
	this.init = function(){
		
		_locale = document.getElementById('countryLookupStrings');
		
		prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch('extensions.countrylookup.');		
		
		if(prefs.getBoolPref('load-local-database')){
			constructLookupDatabase();
			loadLookupDatabase();
		}
		
		document.getElementById("countryLookupIcon").addEventListener('click', countryLookup.mapOpener.click, true);
		
		const listener = new function(){
			this.onStartHeaders	= function(){};
			this.onEndHeaders	= dispRoute;
		};

		gMessageListeners.push(listener);
	};
	
	this.mapOpener = new function(){
		var country = null;
		
		this.updateCountry = function(newCountry){
			country = newCountry;
		};
		
		this.click = function(){
			openDialog("chrome://countrylookup/content/moreInfo.xul", "moreInfo", "chrome", country);
		};
	};
};

addEventListener('messagepane-loaded', countryLookup.init, true);